/* code to manage the stuff on the "earth view" display.
 */

#include <stdio.h>
#include <ctype.h>
#include <math.h>

#if defined(__STDC__)
#include <stdlib.h>
#else
extern void *malloc(), *realloc();
#endif

#include <X11/Xlib.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/DrawingA.h>
#include <Xm/Separator.h>
#include <Xm/ToggleB.h>
#include <Xm/Scale.h>
#include <Xm/CascadeB.h>
#include "astro.h"
#include "circum.h"
#include "map.h"
#include "preferences.h"

#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

extern Now *mm_get_now P_((void));
extern Obj *db_basic P_((int id));
extern double mjd_day P_((double jd));
extern double mjd_hr P_((double jd));
extern int any_ison P_((void));
extern int get_color_resource P_((Widget w, char *cname, Pixel *p));
extern int obj_cir P_((Now *np, Obj *op));
extern void f_dms_angle P_((Widget w, double a));
extern void fs_date P_((char out[], double jd));
extern void fs_time P_((char out[], double t));
extern void fs_pangle P_((char out[], double a));
extern void f_double P_((Widget w, char *fmt, double f));
extern void get_something P_((Widget w, char *resource, char *value));
extern void set_something P_((Widget w, char *resource, char *value));
extern void get_xmlabel_font P_((Widget w, XFontStruct **f));
extern void hlp_dialog P_((char *tag, char *deflt[], int ndeflt));
extern void precess P_((double mjd1, double mjd2, double *ra, double *dec));
extern void range P_((double *v, double r));
extern void redraw_screen P_((int how_much));
extern void register_selection P_((char *name));
extern void f_showit P_((Widget w, char *s));
extern void fs_dms_angle P_((char out[], double a));
extern void set_xmstring P_((Widget w, char *resource, char *txt));
extern char *syserrstr P_((void));
extern void solve_sphere P_((double A, double b, double cosc, double sinc,
    double *cosap, double *Bp));
extern void timestamp P_((Now *np, Widget w));
extern void utc_gst P_((double Mjd, double utc, double *gst));
extern void watch_cursor P_((int want));
extern void xe_msg P_((char *msg, int app_modal));
extern FILE *fopenh P_((char *name, char *how));

void e_manage P_((void));
void e_update P_((Now *np, int force));
int e_ison P_((void));
void e_newobj P_((int dbidx));
void e_selection_mode P_((int whether));
void e_cursor P_((Cursor c));
static void e_create_form P_((void));
static void e_read_sites P_((void));
static void e_point_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_stat_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_close_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_set_buttons P_((int whether));
static void e_help_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_exp_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_motion_cb P_((Widget w, XtPointer client, XEvent *ev,
    Boolean *continue_to_dispatch));
static void e_obj_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_objing_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_tb_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_setmain_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_latlong_cb P_((Widget w, XtPointer client, XtPointer call));
static void e_track_latlng P_((Widget w, XEvent *ev, int r, int x, int y,
    unsigned wide));
static void e_popup P_((Widget w, XEvent *ev, unsigned r, int x, int y));
static void e_create_popup P_((void));
static void e_init_gcs P_((Display *dsp, Window win));
static void e_copy_pm P_((void));
static void e_setelatlng P_((double lt, double lg));
static void e_subobject P_((Now *np, int dbidx, double *latp, double *longp));
static void e_show_esat_stats P_((void));
static void e_coord P_((double svl, double cvl, double vL, double pl,
    double pL, double *sRp, double *cRp, double *sAp, double *cAp));
static void e_drawgrid P_((unsigned r, unsigned wb, unsigned hb));
static void e_drawobjects P_((unsigned r, unsigned wb, unsigned hb));
static void e_drawsat P_((unsigned r, unsigned wb, unsigned hb, double slat,
    double slng, double el));
static void e_drawcircle P_((unsigned r, unsigned wb, unsigned hb, double slat,
    double slng, double rad));
static void e_drawcross P_((unsigned r, unsigned wb, unsigned hb, double lt,
    double lg, int style));
static void e_project P_((unsigned r, unsigned wb, unsigned hb, double sR,
    double sT, double cT, short *xp, short *yp));
static int e_uncoord P_((unsigned int r, int x, int y, double *ltp,
    double *lgp));
static void e_all P_((Now *np));
static void e_getcircle P_((unsigned int *wp, unsigned int *hp,
    unsigned int *rp, unsigned int *xbp, unsigned int *ybp));
static void e_map P_((Now *np));
static void e_mainmenuloc P_((Now *np, unsigned r, unsigned wb, unsigned hb));
static void e_sunside P_((Now *np, unsigned int r, unsigned int wb,
    unsigned int hb));
static void e_drawcontinents P_((unsigned r, unsigned wb, unsigned hb));
static void e_drawsites P_((unsigned r, unsigned wb, unsigned hb));
static void e_viewrad P_((double height, double alt, double *radp));
static void e_resettrails P_((Now *np));
static void e_addtrail P_((Now *np));

#undef P_

/* these are from earthmap.c */
extern MRegion ereg[];
extern int nereg;

extern Widget	toplevel_w;
extern char	*myclass;
#define XtD     XtDisplay(toplevel_w)

/* this is to form a linked-list of sites */
struct _Site {
    struct _Site *si_nxt;	/* next Site, or NULL */
    float si_lat;	/* lat (+N), rads */
    float si_lng;	/* long (+E), rads */
    float si_elev;	/* elevation above sea level, meters (-1 means ?) */
    char si_name[1];	/* site name, used as a varable-length member */
};
typedef struct _Site Site;

static Site *sites;	/* first Site in list, else NULL */

#define	MAXSITELLEN	256	/* maximum site file line length */

static char sitefdef[] = "xephem_sites"; /* default name of sites file */

static int e_selecting;	/* set while our fields are being selected */

static Widget eform_w;	/* main form dialog */
static Widget e_da_w;	/* map DrawingArea widget */
static Widget e_dt_w;	/* date/time stamp label widget */
static Pixmap e_pm;	/* use off screen pixmap for smoother drawing */
static Widget track_w;	/* toggle button to control tracking */
static Widget sites_w;	/* toggle button to control whether to show sites */
static Widget showobj_w;/* toggle button to control whether to show object */
static Widget objX_w, objY_w;	/* pulldown menu widgets for objs X and Y */
static Widget objom_w;	/* the OptionMenu */
static Widget defobj_w;	/* pulldown menu widgets for the default object */
static Widget lat_w;	/* latitude scale widget */
static Widget long_w;	/* longitude scale widget */
static Pixel e_fg, e_bg;/* fg and bg colors */
static GC e_strgc;	/* used for text within the drawing area */
static GC e_olgc;	/* used to draw map overlay details */
static GC e_gc;		/* used for all other GXCopy map drawing uses */
static XFontStruct *e_f;/* used to compute string extents */

/* this is to stave info about the popup: widgets, and current pointing dir.
 */
#define	MAXPUL	5	/* max label widgets we ever need at once */
typedef struct {
    Widget pu_w;	/* main Popup parent widget */
    Widget pu_labels[MAXPUL];	/* the misc labels */
    double pu_lt;	/* current latitude storage */
    double pu_lg;	/* current longitude storage */
} PopupInfo;
static PopupInfo pu_info;

/* info to get and keep track of the colors.
 * if we can't get all of them, we set them to fg/bg and use xor operations.
 * this is all set up in e_init_gcs().
 * N.B. the order of the entries in the enum must match the stuff in ecolors[].
 */
enum EColors {BORDERC, GRIDC, SITEC, OBJC, SUNC, HEREC};
#define	NCOLORS 6
typedef struct {
    char *name;
    Pixel p;
} EColor;
static EColor ecolors[NCOLORS] = {
    {"EarthBorderColor"},
    {"EarthGridColor"},
    {"EarthSiteColor"},
    {"EarthObjColor"},
    {"EarthSunColor"},
    {"EarthHereColor"}
};

/* info to keep track of all the "wants" toggle buttons. 
 * N.B. the wantTBs array init order relies on the order of the enum entries.
 */
enum Wants {		/* client codes for e_tb_cb and indices into wants[] */
    TRACK, TRAILS, GRID, OBJ, SITES, SUNLIGHT
};
#define	NWANTS	6	/* number of entries in the Wants enum */
static wants[NWANTS];	/* fast state for each of the "wants" toggle buttons */
typedef struct {
    char *title;	/* title to be shown */
    char *tbname;	/* name of the toggle button */
    Widget *wp;		/* widget of the toggle button, or 0 if don't need it */
} WantTBs;
static WantTBs wantTBs[NWANTS] = {
    {"Track Object", 	"track", 	&track_w},
    {"Leave Trail",	"trail",	(Widget *)NULL},
    {"Show Grid",	"grid",		(Widget *)NULL},
    {"Show Object",	"object",	&showobj_w},
    {"Show Sites",	"sites",	&sites_w},
    {"Show Sunlight",	"sunlight",	(Widget *)NULL},
};


enum {SET_MAIN, SET_FROM_MAIN};	/* client codes for e_setmain_cb */

static double elat, elng;	/* view center lat/long: +N +E rads */
static double selat, celat;	/* sin and cos os elat */

/* following is to support the table the various statistics displayed down
 * the left edge of the Earth dialog box.
 */
typedef struct {
    char *selname;	/* name by which it is known for plotting etc */
    char *label;	/* label, else NULL if depends on preference */
    int enumcode;	/* one of the ES_ codes (just a check on right order) */
    Widget lw;		/* stat value label widget */
    Widget pbw;		/* stat value pushbutton widget */
} ESatStatTable;

/* code for each of the ess_ (s_*) fields unique to the Earth satellites.
 * N.B. must be in same order as the estattable entries!!
 */
enum estat {ES_SUBLAT, ES_SUBLONG, ES_ELEV, ES_RANGE, ES_RANGER, ES_ECLIPSED};

/* table to describe each statistic.
 * N.B. must be in same order as the estat entries!!
 */
static ESatStatTable estattable[] = {
    {"ESat.SubLat",	"Sub Latitude:",	ES_SUBLAT},
    {"ESat.SubLong",	"Sub Longitude:",	ES_SUBLONG},
    {"ESat.Elevation",	NULL,			ES_ELEV},
    {"ESat.Range",	NULL,			ES_RANGE},
    {"ESat.RangeRate",	NULL,			ES_RANGER},
    {"ESat.Eclipsed",	"In Sun Shadow:",	ES_ECLIPSED}
};

#define	DEFOBJ	SUN			/* default object to track */

#define	WIDE_LW		2		/* wide line width */
#define	NARROW_LW	0		/* narrow line width */
#define	LINE_ST		LineSolid	/* line style for lines */
#define	CAP_ST		CapRound	/* cap style for lines */
#define	JOIN_ST		JoinRound	/* join style for lines */
#define	CROSSH		1		/* drawcross code for a cross hair */
#define	PLUSS		2		/* drawcross code for a plus sign */
#define	PLLEN		degrad(4)	/* plussign arm radius, rads */
#define	CHLEN		degrad(4)	/* cross hair leg length, rads */
#define	LNGSTEP		15		/* longitude grid spacing, degrees */
#define	LATSTEP		15		/* latitude grid spacing, degrees */
#define	NLATLNG		50		/* max segments per grid line */
#define	MAXDIST		degrad(3)	/* max popup search distance, rads */


/* info to keep track of earlier objects while we are keeping trails.
 */
typedef struct {
    Now t_now;	/* Now when this object was first displayed */
    Obj t_obj;	/* it's Obj when this object was first displayed */
    double t_sublat, t_sublng;	/* sub lat/lng of object at this time */
} Trail;

/* Trails are kept as a variable-length malloc'd array of Trail objects.
 * N.B. even without want_trails on, we keep the current object in here too.
 * the entry corresponding to Now is always the last one on the list.
 * avoid dups because we may be drawing with xor.
 */
static Trail *trails;	/* malloc'ed array of Trails */
static int ntrails;	/* number of entries in the trail[] array */
static int object_dbidx;/* dbidx of current object */

void
e_manage()
{
	if (!eform_w) {
	    /* first call: create and init view to main menu's loc.
	     * rely on an expose to do the drawing.
	     */
	    Now *np = mm_get_now();

	    object_dbidx = DEFOBJ;
	    e_create_form();
	    e_read_sites();
	    e_setelatlng (lat, lng);
	    e_addtrail (np);
	}

	if (XtIsManaged(eform_w))
	    XtUnmanageChild(eform_w);
	else {
	    XtManageChild(eform_w);
	    e_set_buttons(e_selecting);
	}
}

/* update the earth details.
 * remove all trail history if it's off now.
 */
void
e_update(np, force)
Now *np;
int force;
{
	/* don't bother if we've never been created or if we're not
	 * up now and no one cares about our values.
	 */
	if (!eform_w)
	    return;
	if (!XtIsManaged(eform_w) && !any_ison() && !force)
	    return;

	if (!wants[TRAILS])
	    e_resettrails(np);
	e_addtrail (np);

	e_all (np);
}

e_ison()
{
	return (eform_w && XtIsManaged(eform_w));
}

/* called when a user-defined object has changed.
 * we can assume that our update function will also be called subsequently.
 * if the object being changed is the one we are currently displaying
 *   and it is now undefined turn off tracking and trailing and change the
 *   current object to be the Sun.
 */
void
e_newobj (dbidx)
int dbidx;	/* OBJX or OBJY */
{
	Now *np = mm_get_now();
	Obj *op;

	if (dbidx != object_dbidx) 
	    return;	/* doesn't effect us */

	op = db_basic (dbidx);

	/* change to the new object.
	 * setting menuHistory changes the the cascade button 
	 * we still need to be sure the string in that widget is correct.
	 */
	if (op->type == UNDEFOBJ) {
	    object_dbidx = DEFOBJ;
	    set_something (objom_w, XmNmenuHistory, (char *)defobj_w);
	} else {
	    object_dbidx = dbidx;
	    switch (dbidx) {
	    case OBJX:
		set_xmstring (XmOptionButtonGadget(objom_w), XmNlabelString,
								op->o_name);
		set_something (objom_w, XmNmenuHistory, (char *)objX_w);
		break;
	    case OBJY:
		set_xmstring (XmOptionButtonGadget(objom_w), XmNlabelString,
								op->o_name);
		set_something (objom_w, XmNmenuHistory, (char *)objY_w);
		break;
	    default:
		printf ("e_newobj(): bogus dbidx: %d\n", dbidx);
		exit (1);
	    }
	}

	/* discard the old trail history and add one for new object */
	e_resettrails(np);
	e_all (np);
}

/* called by other menus as they want to hear from our buttons or not.
 * the ons and offs stack.
 */
void
e_selection_mode (whether)
int whether;
{
	e_selecting += whether ? 1 : -1;

	if (e_ison())
	    if (whether && e_selecting == 1	   /* first one to want on */
		|| !whether && e_selecting == 0 /* first one to want off */)
		e_set_buttons (whether);
}

void
e_cursor(c)
Cursor c;
{
	Window win;

	if (eform_w && (win = XtWindow(eform_w))) {
	    Display *dsp = XtDisplay(eform_w);
	    if (c)
		XDefineCursor(dsp, win, c);
	    else
		XUndefineCursor(dsp, win);
	}
}

static void
e_create_form()
{
	static struct {
	    char *name;
	    void (*cb)();
	    int client;
	} ctls[] = {
	    {"Close", e_close_cb, 0},
	    {"Set Main", e_setmain_cb, SET_MAIN},
	    {"Set From Main", e_setmain_cb, SET_FROM_MAIN},
	    {"Help", e_help_cb, 0}
	};
	Widget w;
	Widget f_w;
	Widget ctlsep_w, vsep_w;
	Widget pdm_w;
	Widget rc_w, vrc_w;
	EventMask mask;
	Arg args[20];
	int n;
	int i;

	/* create form */

	n = 0;
	XtSetArg (args[n], XmNautoUnmanage, False); n++;
	XtSetArg (args[n], XmNdefaultPosition, False); n++;
	XtSetArg (args[n], XmNresizePolicy, XmRESIZE_NONE); n++;
	XtSetArg (args[n], XmNhorizontalSpacing, 2); n++;
	eform_w = XmCreateFormDialog (toplevel_w, "Earth", args,n);
	XtAddCallback (eform_w, XmNhelpCallback, e_help_cb, 0);

	/* set some stuff in the parent DialogShell.
	 * setting XmNdialogTitle in the Form didn't work..
	 */
	n = 0;
	XtSetArg (args[n], XmNtitle, "xephem Earth view"); n++;
	XtSetValues (XtParent(eform_w), args, n);

	/* make the bottom control panel form and its buttons */

	n = 0;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNfractionBase, 25); n++;
	f_w = XmCreateForm (eform_w, "CtlF", args, n);
	XtManageChild (f_w);

	    for (i = 0; i < XtNumber(ctls); i++) {
		n = 0;
		XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
		XtSetArg (args[n], XmNtopOffset, 5); n++;
		XtSetArg (args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
		XtSetArg (args[n], XmNbottomOffset, 5); n++;
		XtSetArg (args[n], XmNleftAttachment, XmATTACH_POSITION); n++;
		XtSetArg (args[n], XmNleftPosition, 1+i*6); n++;
		XtSetArg (args[n], XmNrightAttachment, XmATTACH_POSITION); n++;
		XtSetArg (args[n], XmNrightPosition, 6+i*6); n++;
		w = XmCreatePushButton (f_w, ctls[i].name, args, n);
		XtManageChild (w);
		XtAddCallback (w, XmNactivateCallback, ctls[i].cb,
						    (XtPointer)ctls[i].client);
	    }

	/* make a separator over the bottom control form */

	n = 0;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, f_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	ctlsep_w = XmCreateSeparator (eform_w, "Sep", args, n);
	XtManageChild(ctlsep_w);

	/* make a rowcolumn down the left for the object and "wants" controls.
	 * this does *NOT* contain the statistics displays (they're in their
	 * own rc, next).
	 */

	n = 0;
	XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNisAligned, False); n++;
	XtSetArg (args[n], XmNadjustLast, False); n++;
	XtSetArg (args[n], XmNadjustMargin, False); n++;
	XtSetArg (args[n], XmNmarginWidth, 0); n++;
	XtSetArg (args[n], XmNspacing, 0); n++;
	rc_w = XmCreateRowColumn (eform_w, "ERC", args, n);
	XtManageChild(rc_w);

	    /* make all the "wants" controls */

	    for (i = 0; i < NWANTS; i++) {
		WantTBs *wp = &wantTBs[i];
		XmString str;

		str = XmStringCreateLtoR (wp->title, XmSTRING_DEFAULT_CHARSET);
		n = 0;
		XtSetArg (args[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
		XtSetArg (args[n], XmNlabelString, str); n++;
		w = XmCreateToggleButton (rc_w, wp->tbname, args, n);
		wants[i] = XmToggleButtonGetState(w);
		XtAddCallback (w, XmNvalueChangedCallback,e_tb_cb,(XtPointer)i);
		XtManageChild (w);
		if (wp->wp)
		    *wp->wp = w;
		XmStringFree (str);
	    }

	    n = 0;
	    w = XmCreateSeparator (rc_w, "EColSep", args, n);
	    XtManageChild (w);

	    /* make the Object optionbutton and its pulldown */

	    n = 0;
	    pdm_w = XmCreatePulldownMenu (eform_w, "ObjectPD", args, n);

		/* create the pushbuttons forming the cascade menu.
		 * go ahead and fill in and manage the planet names now.
		 * we do the user objects just as we are cascading.
		 */
		for (i = 0; i < NOBJ; i++) {
		    n = 0;
		    w = XmCreatePushButton (pdm_w, "ObjectPB", args, n);
		    XtAddCallback (w, XmNactivateCallback, e_obj_cb,
								(XtPointer)i);
		    if (i >= MERCURY && i <= MOON) {
			Obj *op = db_basic (i);
			set_xmstring (w, XmNlabelString, op->o_name);
			XtManageChild (w);
		    } else if (i == OBJX)
			objX_w = w;
		    else if (i == OBJY)
			objY_w = w;

		    /* save a button widget so we can use it as a default
		     * if we are ever displaying a user-defined object and
		     * it becomes undefined.
		     */
		    if (i == DEFOBJ)
			defobj_w = w;
		}

	    n = 0;
	    XtSetArg (args[n], XmNsubMenuId, pdm_w); n++;
	    XtSetArg (args[n], XmNmenuHistory, defobj_w); n++;
	    objom_w = XmCreateOptionMenu (rc_w, "ObjectOM", args, n);
	    XtAddCallback (XmOptionButtonGadget(objom_w), XmNcascadingCallback,
								e_objing_cb, 0);
	    set_xmstring (XmOptionLabelGadget(objom_w), XmNlabelString, "Obj:");
	    XtManageChild (objom_w);

	    n = 0;
	    w = XmCreateSeparator (rc_w, "EColSep", args, n);
	    XtManageChild (w);

	/* make each earth satellite statistic label/value pair.
	 * only manage now the ones that are always up.
	 * make them in a separate rc; this helps keep things stable sized as
	 * fields are managed on/off
	 */

	n = 0;
	XtSetArg (args[n], XmNtopAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNtopWidget, rc_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNisAligned, False); n++;
	XtSetArg (args[n], XmNadjustLast, False); n++;
	XtSetArg (args[n], XmNadjustMargin, False); n++;
	XtSetArg (args[n], XmNmarginWidth, 0); n++;
	XtSetArg (args[n], XmNspacing, 0); n++;
	vrc_w = XmCreateRowColumn (eform_w, "EVRC", args, n);
	XtManageChild(vrc_w);

	    for (i = 0; i < XtNumber (estattable); i++) {
		ESatStatTable *stp = estattable + i;
		XmString str;

		/* create the labels for the ones that don't change depending
		 * upon preferences.
		 */
		n = 0;
		str = 0;
		if (stp->label) {
		    str = XmStringCreateLtoR (stp->label,
						    XmSTRING_DEFAULT_CHARSET);
		    XtSetArg (args[n], XmNlabelString, str); n++;
		}
		XtSetArg (args[n], XmNalignment, XmALIGNMENT_BEGINNING); n++;
		stp->lw = XmCreateLabel (vrc_w, "ESatStatLabel", args, n);
		if (str)
		    XmStringFree (str);

		n = 0;
		XtSetArg (args[n], XmNalignment, XmALIGNMENT_CENTER); n++;
		XtSetArg (args[n], XmNuserData, stp->selname); n++;
		stp->pbw = XmCreatePushButton (vrc_w, "ESatStatPB", args, n);
		XtAddCallback (stp->pbw, XmNactivateCallback, e_stat_cb, 0);

		switch (stp->enumcode) {
		case ES_SUBLONG:
		case ES_SUBLAT:
		    XtManageChild (stp->lw);
		    XtManageChild (stp->pbw);
		    break;
		}
	    }

	/* make a vertical separator to the right of the left column stuff */

	n = 0;
	XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, ctlsep_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNleftWidget, rc_w); n++;
	XtSetArg (args[n], XmNorientation, XmVERTICAL); n++;
	vsep_w = XmCreateSeparator (eform_w, "EVSep", args, n);
	XtManageChild (vsep_w);

	/* make the date/time indicator label */

	n = 0;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, ctlsep_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNleftWidget, vsep_w); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNalignment, XmALIGNMENT_CENTER); n++;
	e_dt_w = XmCreateLabel (eform_w, "DTstamp", args, n);
	XtManageChild (e_dt_w);

	/* make the long and lat scales */

	n = 0;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, e_dt_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNleftWidget, vsep_w); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNminimum, -180); n++;
	XtSetArg (args[n], XmNmaximum, 180); n++;
	XtSetArg (args[n], XmNprocessingDirection, XmMAX_ON_LEFT); n++;
	XtSetArg (args[n], XmNscaleMultiple, 1); n++;
	XtSetArg (args[n], XmNorientation, XmHORIZONTAL); n++;
	XtSetArg (args[n], XmNshowValue, True); n++;
	long_w = XmCreateScale (eform_w, "LongS", args, n);
	XtAddCallback (long_w, XmNvalueChangedCallback, e_latlong_cb, NULL);
	XtManageChild (long_w);

	n = 0;
	XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, long_w); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNminimum, -90); n++;
	XtSetArg (args[n], XmNmaximum, 90); n++;
	XtSetArg (args[n], XmNprocessingDirection, XmMAX_ON_TOP); n++;
	XtSetArg (args[n], XmNscaleMultiple, 1); n++;
	XtSetArg (args[n], XmNorientation, XmVERTICAL); n++;
	XtSetArg (args[n], XmNshowValue, True); n++;
	lat_w = XmCreateScale (eform_w, "LatS", args, n);
	XtAddCallback (lat_w, XmNvalueChangedCallback, e_latlong_cb, NULL);
	XtManageChild (lat_w);

	/* make a drawing area on top */

	n = 0;
	XtSetArg (args[n], XmNtopAttachment, XmATTACH_FORM); n++;
	XtSetArg (args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNbottomWidget, long_w); n++;
	XtSetArg (args[n], XmNleftAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNleftWidget, vsep_w); n++;
	XtSetArg (args[n], XmNrightAttachment, XmATTACH_WIDGET); n++;
	XtSetArg (args[n], XmNrightWidget, lat_w); n++;
	e_da_w = XmCreateDrawingArea (eform_w, "Map", args, n);
	XtAddCallback (e_da_w, XmNexposeCallback, e_exp_cb, NULL);
	mask = Button1MotionMask | ButtonPressMask | ButtonReleaseMask
						    | PointerMotionHintMask,
	XtAddEventHandler (e_da_w, mask, False, e_motion_cb, 0);
	XtManageChild (e_da_w);
}

/* read in the sites file */
static void
e_read_sites()
{
	char buf[MAXSITELLEN];
	char msg[128];
	char *fn;
	FILE *fp;

	fn = XGetDefault (XtD, myclass, "SITESFILE");
	if (!fn)
	    fn = sitefdef;

	fp = fopenh (fn, "r");
	if (!fp) {
	    (void) sprintf(msg, "Can not open %.75s: %.25s", fn, syserrstr());

	    XtSetSensitive (sites_w, False);
	    XmToggleButtonSetState (sites_w, False, False);
	    xe_msg (msg, 0);
	    return;
	}

	while (fgets (buf, sizeof(buf), fp) != NULL) {
	    char name[MAXSITELLEN];
	    int latd, latm, lats;
	    int lngd, lngm, lngs;
	    char latNS, lngEW;
	    double ele;
	    int nf;

	    nf = sscanf (buf, "%[^;]; %3d %2d %2d %c   ; %3d %2d %2d %c   ;%lf",
					    name, &latd, &latm, &lats, &latNS,
					    &lngd, &lngm, &lngs, &lngEW, &ele);
	    if (nf == 10) {
		double lt, lg;
		Site *sp;
		int l;

		/* strip trailing blanks */
		for (l = strlen (name); --l >= 0; )
		    if (isspace(name[l]))
			name[l] = '\0';
		    else
			break;
		lt = degrad (latd + latm/60.0 + lats/3600.0);
		if (latNS == 'S')
		    lt = -lt;
		lg = degrad (lngd + lngm/60.0 + lngs/3600.0);
		if (lngEW == 'W')
		    lg = -lg;
		sp = (Site *) malloc (sizeof(Site) + strlen(name));
		sp->si_lat = lt;
		sp->si_lng = lg;
		sp->si_elev = ele;
		(void) strcpy (sp->si_name, name);
		sp->si_nxt = sites;
		sites = sp;
	    }
	}

	(void) fclose (fp);
}

/* callback when any of the stat buttons are activated. */
/* ARGSUSED */
static void
e_stat_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	if (e_selecting) {
	    char *userD;
	    get_something (w, XmNuserData, (char *)&userD);
	    register_selection (userD);
	}
}

/* callback for when the Close button is activated. */
/* ARGSUSED */
static void
e_close_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	XtUnmanageChild (eform_w);
	if (e_pm) {
	    XFreePixmap (XtDisplay(w), e_pm);
	    e_pm = NULL;
	}
}

/* go through all the buttons and set whether they
 * should appear to look like buttons or just flat labels.
 */
static void
e_set_buttons (whether)
int whether;	/* whether setting up for plotting or for not plotting */
{
	static Arg look_like_button[] = {
	    {XmNtopShadowColor, (XtArgVal) 0},
	    {XmNbottomShadowColor, (XtArgVal) 0},
            {XmNtopShadowPixmap, (XtArgVal) 0},
            {XmNbottomShadowPixmap, (XtArgVal) 0},
	    {XmNfillOnArm, (XtArgVal) True},
	    {XmNtraversalOn, (XtArgVal) True},
	};
	static Arg look_like_label[] = {
	    {XmNtopShadowColor, (XtArgVal) 0},
	    {XmNbottomShadowColor, (XtArgVal) 0},
            {XmNtopShadowPixmap, (XtArgVal) 0},
            {XmNbottomShadowPixmap, (XtArgVal) 0},
	    {XmNfillOnArm, (XtArgVal) False},
	    {XmNtraversalOn, (XtArgVal) False},
	};
	static int called;
	Arg *ap;
	int na;
	int i;

	if (!called) {
	    /* get baseline label and shadow appearances.
	     */
            Pixel topshadcol, botshadcol, bgcol;
            Pixmap topshadpm, botshadpm;
	    Arg args[20];
	    int n;

	    n = 0;
            XtSetArg (args[n], XmNtopShadowColor, &topshadcol); n++;
            XtSetArg (args[n], XmNbottomShadowColor, &botshadcol); n++;
            XtSetArg (args[n], XmNtopShadowPixmap, &topshadpm); n++;
            XtSetArg (args[n], XmNbottomShadowPixmap, &botshadpm); n++;
	    XtSetArg (args[n], XmNbackground, &bgcol); n++;
	    XtGetValues (track_w, args, n);

            look_like_button[0].value = topshadcol;
            look_like_button[1].value = botshadcol;
            look_like_button[2].value = topshadpm;
            look_like_button[3].value = botshadpm;
            look_like_label[0].value = bgcol;
            look_like_label[1].value = bgcol;
            look_like_label[2].value = XmUNSPECIFIED_PIXMAP;
            look_like_label[3].value = XmUNSPECIFIED_PIXMAP;

	    called = 1;
	}

	if (whether) {
	    ap = look_like_button;
	    na = XtNumber(look_like_button);
	} else {
	    ap = look_like_label;
	    na = XtNumber(look_like_label);
	}

	for (i = 0; i < XtNumber(estattable); i++)
	    XtSetValues (estattable[i].pbw, ap, na);
}

/* callback from the Help button
 */
/* ARGSUSED */
static void
e_help_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	static char *msg[] = {
"This is a simple schematic depiction of the Earth surface at the given time.",
"The view shows the sunlit portion and the location of any object.",
};

	hlp_dialog ("Earth", msg, XtNumber(msg));
}

/* called whenever the earth drawing area gets an expose.
 */
/* ARGSUSED */
static void
e_exp_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	static unsigned int wid_last, hei_last;
	XmDrawingAreaCallbackStruct *c = (XmDrawingAreaCallbackStruct *)call;
	Display *dsp = XtDisplay(w);
	Window win = XtWindow(w);
	Window root;
	int x, y;
	unsigned int bw, d;
	unsigned wid, hei;

	/* filter out a few oddball cases */
	switch (c->reason) {
	case XmCR_EXPOSE: {
	    /* turn off gravity so we get expose events for either shrink or
	     * expand.
	     */
	    static before;
	    XExposeEvent *e = &c->event->xexpose;

	    if (!before) {
		XSetWindowAttributes swa;
		swa.bit_gravity = ForgetGravity;
		XChangeWindowAttributes (e->display, e->window, 
							    CWBitGravity, &swa);
		before = 1;
	    }
	    /* wait for the last in the series */
	    if (e->count != 0)
		return;
	    break;
	    }
	default:
	    printf ("Unexpected eform_w event. type=%d\n", c->reason);
	    exit(1);
	}

	/* if no pixmap or we're a new size then (re)build everything */
	XGetGeometry (dsp, win, &root, &x, &y, &wid, &hei, &bw, &d);
	if (!e_pm || wid != wid_last || hei != hei_last) {
	    if (e_pm)
		XFreePixmap (dsp, e_pm);

	    if (!e_gc)
		e_init_gcs(dsp, win);

	    e_pm = XCreatePixmap (dsp, win, wid, hei, d);
	    wid_last = wid;
	    hei_last = hei;

	    e_all(mm_get_now());
	} else {
	    /* nothing new so just copy from the pixmap */
	    e_copy_pm();
	}
}

/* called on receipt of a MotionNotify or ButtonPress or ButtonRelease event
 *   while the cursor is wandering over the Earth and button 1 is down or
 *   Button3 is pressed.
 * button 1 causes a report of the current location in world coordinates;
 * button 3 causes a popup.
 */
/* ARGSUSED */
static void
e_motion_cb (w, client, ev, continue_to_dispatch)
Widget w;
XtPointer client;
XEvent *ev;
Boolean *continue_to_dispatch;
{
	int trackmotion, trackbutton, popupbutton;
	int evt = ev->type;


	trackmotion = evt == MotionNotify && ev->xmotion.state == Button1Mask;
	trackbutton = (evt == ButtonPress || evt == ButtonRelease)
					&& ev->xbutton.button == Button1;
	popupbutton = evt == ButtonPress && ev->xbutton.button == Button3;

	if (popupbutton || trackmotion || trackbutton) {
	    unsigned wide, h, r, xb, yb;
	    Window root, child;
	    int rx, ry, wx, wy;
	    unsigned mask;

	    XQueryPointer (XtDisplay(w), XtWindow(w),
				&root, &child, &rx, &ry, &wx, &wy, &mask);

	    e_getcircle (&wide, &h, &r, &xb, &yb);

	    if (popupbutton)
		e_popup (w, ev, r, wx-(int)xb, wy-(int)yb);
	    else
		e_track_latlng (w, ev, r, wx-(int)xb, wy-(int)yb, wide);
	}
}

/* called when the one of the Object pulldown buttons is activated.
 * make that object the one to view now.
 * the object id is client.
 */
/* ARGSUSED */
static void
e_obj_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	Now *np = mm_get_now();
	Obj *op;
	int dbidx;

	dbidx = (int)client;
	if (!(op = db_basic (dbidx)) || op->type == UNDEFOBJ) {
	    printf ("e_obj_cb: bad dbidx: %d\n", dbidx);
	    exit (1);
	}

	object_dbidx = dbidx;

	/* restart the trail history based on the new object now */
	e_resettrails(mm_get_now());

	e_all (np);
}

/* called when the pulldown menu from the Object cascade button is cascading.
 * check whether ObjX and Y and defined and if so set their names in the
 * pulldown else turn these selections off.
 */
/* ARGSUSED */
static void
e_objing_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	Obj *op;

	op = db_basic (OBJX);
	if (op->type != UNDEFOBJ) {
	    set_xmstring (objX_w, XmNlabelString, op->o_name);
	    XtManageChild (objX_w);
	} else
	    XtUnmanageChild (objX_w);

	op = db_basic (OBJY);
	if (op->type != UNDEFOBJ) {
	    set_xmstring (objY_w, XmNlabelString, op->o_name);
	    XtManageChild (objY_w);
	} else
	    XtUnmanageChild (objY_w);
}

/* called when any of the toggle buttons changes state.
 * client is one of the Wants enum.
 */
/* ARGSUSED */
static void
e_tb_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	Now *np = mm_get_now();
	int state = XmToggleButtonGetState (w);
	int want = (int) client;

	switch (want) {
	case TRACK:
	    wants[want] = state;
	    if (state) {
		/* if turning on tracking, it's nice to also insure Show Object
		 * want is on too.
		 */
		if (!wants[OBJ]) {
		    /* don't call the callback -- that'd do two e_all()'s */
		    XmToggleButtonSetState (showobj_w, True, False);
		    wants[OBJ] = 1;
		}
		e_all (np);
	    }
	    break;
	case TRAILS:
	    wants[want] = state;
	    if (ntrails > 1)
		e_all (np);
	    break;
	case GRID:
	case OBJ:
	case SITES:
	case SUNLIGHT:
	    wants[want] = state;
	    e_all (np);
	    break;
	default:
	    printf ("e_tb_cb: bad client: %d\n", want);
	    exit (1);
	}
}

/* called when Set Main or Set from Main is activated.
 * client is set to SET_MAIN or SET_FROM_MAIN.
 */
/* ARGSUSED */
static void
e_setmain_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	int which = (int)client;
	Now *np = mm_get_now();

	switch (which) {
	case SET_MAIN:
	    lat = elat;
	    lng = elng;
	    redraw_screen (1);
	    break;
	case SET_FROM_MAIN:
	    e_setelatlng (lat, lng);
	    XmToggleButtonSetState (track_w, False, True);
	    e_all (np);
	    break;
	default:
	    printf ("e_setmain_cb: Bad client: %d\n", which);
	    exit (1);
	}
}

/* called when either the longitude or latitude scale moves.
 * doesn't matter which -- just update pointing direction and redraw.
 * as a convenience, also insure tracking is off now.
 */
/* ARGSUSED */
static void
e_latlong_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	int lt, lg;

	XmScaleGetValue (lat_w, &lt);
	XmScaleGetValue (long_w, &lg);
	e_setelatlng (degrad(lt), degrad(-lg)); /* want +E but scale is +W */

	XmToggleButtonSetState (track_w, False, True);

	e_all (mm_get_now());
}

/* called when the Point button is selected on the roaming popup.
 * center the point of view to point_lt/point_lg.
 * as a convenience, also turn off tracking.
 */
/* ARGSUSED */
static void
e_point_cb (w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
	e_setelatlng (pu_info.pu_lt, pu_info.pu_lg);
	XmToggleButtonSetState (track_w, False, True);
	e_all (mm_get_now());
}

/* make all the GCs, define all the e_*pix pixels and set the XFontStruct e_f
 *   from the track_w widget.
 * we get the color names and save the pixels in the global ecolors[] arrary.
 * if we can't get all of the special colors, just use foreground/background.
 * this is because we will use xor if if any color is missing.
 */
static void
e_init_gcs (dsp, win)
Display *dsp;
Window win;
{
	unsigned long gcm;
	XGCValues gcv;
	Pixel p;
	int all;
	int i;

	/* create the main gc. 
	 * it's GCForeground is set each time it's used.
	 */
	gcm = GCFunction;
	gcv.function = GXcopy;
	e_gc = XCreateGC (dsp, win, gcm, &gcv);

	/* get the foreground and background colors */
	get_something (e_da_w, XmNforeground, (char *)&e_fg);
	get_something (e_da_w, XmNbackground, (char *)&e_bg);

	/* collect all the other Earth colors, and check if we have them all.
	 * we also require them to all be unique.
	 */
	all = 1;
	for (i = 0; all && i < XtNumber(ecolors); i++) {
	    EColor *ecp = &ecolors[i];
	    int j;

	    if (get_color_resource (e_da_w, ecp->name, &ecp->p) < 0) {
		all = 0;
		break;
	    } else {
		for (j = i-1; j >= 0; --j) {
		    if (ecp->p == ecolors[j].p) {
			all = 0;
			break;
		    }
		}
	    }
	}

	/* make the overlay gc, e_olgc. it's GCFunction is set once (here)
	 * depending on whether we have all the desired earth colors or to xor
	 * if we must use fg/bg for everything.
	 */

	if (!all) {
	    /* couldn't get at least one color so use fg/bg and xor */
	    Pixel xorp = e_fg ^ e_bg;

	    xe_msg (
  "Can not get all unique Earth colors so using Earth.Map.fg/bg and xor.", 0);
	    for (i = 0; i < XtNumber(ecolors); i++)
		ecolors[i].p = xorp;

	    /* sun is not drawn with xor */
	    ecolors[SUNC].p = e_fg;

	    gcm = GCFunction;
	    gcv.function = GXxor;
	    e_olgc = XCreateGC (dsp, win, gcm, &gcv);
	} else {
	    /* got all the colors -- overlay can just be drawn directly */
	    gcm = GCFunction;
	    gcv.function = GXcopy;
	    e_olgc = XCreateGC (dsp, win, gcm, &gcv);
	}

	/* make the lat/long string gc and get's it's font */

	gcm = GCForeground | GCBackground | GCFont;
	get_something (track_w, XmNforeground, (char *)&p);
	gcv.foreground = p;
	gcv.background = e_bg;
	get_xmlabel_font (track_w, &e_f);
	gcv.font = e_f->fid;
	e_strgc = XCreateGC (dsp, win, gcm, &gcv);
}

/* copy the pixmap e_pm to the window of e_da_w. */
static void
e_copy_pm()
{
	Display *dsp = XtDisplay(e_da_w);
	Window win = XtWindow(e_da_w);
	unsigned int w, h;
	unsigned int wb, hb, r;

	e_getcircle (&w, &h, &r, &wb, &hb);
	XCopyArea (dsp, e_pm, win, e_gc, 0, 0, w, h, 0, 0);
}

/* right button has been hit: find the closest thing to x/y and display what we
 * know about it. if nothing is very close, at least show the lat/long.
 * always give the choice to point to the stop.
 */
/* ARGSUSED */
static void
e_popup (wid, ev, r, x, y)
Widget wid;
XEvent *ev;
unsigned r;
int x, y;
{
	double lt, lg;
	double A, b, cosc, sinc;	/* see solve_sphere() */
	double cosa, B;			/* see solve_sphere() */
	double mind;
	Site *sip, *minsip;
	Trail *tp, *mintp;
	char buf[128];
	int want_altaz;
	Widget w;
	int i, nl;

	/* find the lat/long under the cursor.
	 * if not over the earth, forget it.
	 */
	if (!e_uncoord (r, x, y, &lt, &lg))
	    return;
	cosc = cos(PI/2 - lt);
	sinc = sin(PI/2 - lt);

	watch_cursor (1);

	/* make the popup if this is our first time */
	if (!pu_info.pu_w)
	    e_create_popup();

	/* find the closest site in minsip, if sites are enabled */
	minsip = 0;
	mind = 1e9;
	if (wants[SITES])
	    for (sip = sites; sip; sip = sip->si_nxt) {
		double d;
		A = sip->si_lng - lg;
		b = PI/2 - sip->si_lat;
		solve_sphere (A, b, cosc, sinc, &cosa, &B);
		d = acos (cosa);
		if (d < mind) {
		    minsip = sip;
		    mind = d;
		}
	    }

	/* now see if there are any history entries even closer.
	 * if so, put it in mintp.
	 * don't do this if the object is not currently being shown.
	 */
	mintp = 0;
	if (wants[OBJ])
	    for (tp = trails; tp && tp < &trails[ntrails]; tp++) {
		double d;
		A = tp->t_sublng - lg;
		b = PI/2 - tp->t_sublat;
		solve_sphere (A, b, cosc, sinc, &cosa, &B);
		d = acos (cosa);
		if (d < mind) {
		    mintp = tp;
		    mind = d;
		}
	    }

	/* build the popup */

	/* first unmanage all the labels -- we'll turn on what we want */
	for (i = 0; i < MAXPUL; i++)
	    XtUnmanageChild (pu_info.pu_labels[i]);
	nl = 0;

	want_altaz = 0;
	if (mind <= MAXDIST) {
	    /* found something, question is: a trailed object or a site?
	     * check them in the opposite order than which they were searched.
	     */
	    if (mintp) {
		/* a trail item was closest.
		 * put the name, time, lat and lng in the popup.
		 */
		w = pu_info.pu_labels[nl++];
		set_xmstring (w, XmNlabelString, mintp->t_obj.o_name);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "UT Date: ");
		fs_date (buf+strlen(buf), mintp->t_now.n_mjd);
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "UT Time: ");
		fs_time (buf+strlen(buf), mjd_hr(mintp->t_now.n_mjd));
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "Lat: ");
		fs_dms_angle (buf+strlen(buf), mintp->t_sublat);
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "Long: ");
		fs_dms_angle (buf+strlen(buf), -mintp->t_sublng); /* want +W */
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		/* save lat/long for Point and if want to display alt/az */
		pu_info.pu_lt = mintp->t_sublat;
		pu_info.pu_lg = mintp->t_sublng;
	    } else if (minsip) {
		/* a site entry was closest.
		 * put it's name, lat/long and alt/az in the popup.
		 */

		want_altaz = 1;

		w = pu_info.pu_labels[nl++];
		set_xmstring (w, XmNlabelString, minsip->si_name);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "Lat: ");
		fs_dms_angle (buf+strlen(buf), minsip->si_lat);
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		w = pu_info.pu_labels[nl++];
		(void) sprintf (buf, "Long: ");
		fs_dms_angle (buf+strlen(buf), -minsip->si_lng); /* want +W */
		set_xmstring (w, XmNlabelString, buf);
		XtManageChild (w);

		/* save lat/long for Point and if want to display alt/az */
		pu_info.pu_lt = minsip->si_lat;
		pu_info.pu_lg = minsip->si_lng;
	    } else {
		printf ("e_popup: unknown closest! mind = %g\n", mind);
		exit (1);
	    }
	} else {
	    /* nothing was close enough.
	     * just put the lat/long and alt/az of the cursor loc in the popup.
	     */

	    want_altaz = 1;

	    w = pu_info.pu_labels[nl++];
	    (void) sprintf (buf, "Lat: ");
	    fs_dms_angle (buf+strlen(buf), lt);
	    set_xmstring (w, XmNlabelString, buf);
	    XtManageChild (w);

	    w = pu_info.pu_labels[nl++];
	    (void) sprintf (buf, "Long: ");
	    fs_dms_angle (buf+strlen(buf), -lg);	/* want +W */
	    set_xmstring (w, XmNlabelString, buf);
	    XtManageChild (w);

	    /* save lat/long for Point and if want to display alt/az */
	    pu_info.pu_lt = lt;
	    pu_info.pu_lg = lg;
	}

	/* if the Object is enabled also display alt/az of the object from
	 * this location in the popup.
	 */
	if (want_altaz && wants[OBJ]) {
	    Now now_here;
	    Obj obj_here;

	    (void) memcpy (&now_here, &trails[ntrails-1].t_now, sizeof (Now));
	    now_here.n_lat = pu_info.pu_lt;
	    now_here.n_lng = pu_info.pu_lg;
	    (void) memcpy (&obj_here, &trails[ntrails-1].t_obj, sizeof (Obj));
	    (void) obj_cir (&now_here, &obj_here);

	    w = pu_info.pu_labels[nl++];
	    (void) sprintf (buf, "Obj Alt: ");
	    fs_pangle (buf+strlen(buf), obj_here.s_alt);
	    set_xmstring (w, XmNlabelString, buf);
	    XtManageChild (w);

	    w = pu_info.pu_labels[nl++];
	    (void) sprintf (buf, "Obj Az: ");
	    fs_pangle (buf+strlen(buf), obj_here.s_az);
	    set_xmstring (w, XmNlabelString, buf);
	    XtManageChild (w);
	}

	XmMenuPosition (pu_info.pu_w, (XButtonPressedEvent *)ev);
	XtManageChild (pu_info.pu_w);

	watch_cursor(0);
}

/* create the popup
 * save all its widget in the pu_info struct.
 */
static void
e_create_popup()
{
	Widget w;
	Arg args[20];
	int n;
	int i;

	/* make the popup shell which includes a handy row/column */
	n = 0;
	XtSetArg (args[n], XmNisAligned, True); n++;
	XtSetArg (args[n], XmNentryAlignment, XmALIGNMENT_CENTER); n++;
	pu_info.pu_w = XmCreatePopupMenu (e_da_w, "EPopup", args, n);

	/* add the max labels we'll ever need -- all unmanaged for now. */
	for (i = 0; i < MAXPUL; i++) {
	    n = 0;
	    pu_info.pu_labels[i] = XmCreateLabel (pu_info.pu_w, "EPUL",args,n);
	}

	/* and add the separator and the "Point" button.
	 * we always wants these so manage them now.
	 */
	w = XmCreateSeparator (pu_info.pu_w, "PUSep", args, 0);
	XtManageChild (w);
	w = XmCreatePushButton (pu_info.pu_w, "Point", args, 0);
	XtAddCallback (w, XmNactivateCallback, e_point_cb, 0);
	XtManageChild (w);
}

/* display the lat/long under the cursor.
 * we are given the radius and x/y of the location, the pointer event and
 * the total window width.
 */
static void
e_track_latlng (w, ev, r, x, y, wide)
Widget w;
XEvent *ev;
int r, x, y;
unsigned int wide;
{
	static dirty;
	double lt, lg;

	if (ev->type != ButtonRelease && e_uncoord (r, x, y, &lt, &lg)) {
	    XCharStruct all;
	    Window win = XtWindow(w);
	    char lng_buf[64], lat_buf[64];
	    int dir, asc, des;
	    int len;

	    (void) strcpy (lat_buf, "Lat: ");
	    fs_dms_angle (lat_buf+5, lt);
	    (void) strcpy (lng_buf, "Long: ");
	    fs_dms_angle (lng_buf+6, -lg);	/* +W */

	    len = strlen (lat_buf);
	    XTextExtents (e_f, lat_buf, len, &dir, &asc, &des, &all);
	    XDrawImageString (XtD, win, e_strgc, 0, asc, lat_buf, len); 

	    len = strlen (lng_buf);
	    XTextExtents (e_f, lng_buf, len, &dir, &asc, &des, &all);
	    XDrawImageString (XtD, win, e_strgc, wide-all.rbearing, asc,
								lng_buf, len);
	    
	    dirty = 1;
	} else if (dirty) {
	    e_copy_pm();
	    dirty = 0;
	}
}

/* set the elat/selat/celat/elng values, taking care to put them into ranges
 * -PI/2 .. elat .. PI/2 and -PI .. elng .. PI.
 */
static void
e_setelatlng (lt, lg)
double lt, lg;
{
	elat = lt;
	selat = sin(elat);
	celat = cos(elat);
	elng = lg;
	range (&elng, 2*PI);
	if (elng > PI)
	    elng -= 2*PI;
}

/* return the long and lat of the subobject point (lat/long of where the object
 * is directly overhead) at np.
 * both are in rads, lat is +N, long is +E.
 */
static void
e_subobject(np, dbidx, latp, longp)
Now *np;
int dbidx;
double *latp, *longp;
{
	Obj *op;

	op = db_basic (dbidx);

	if (op->type == EARTHSAT) {
	    /* these are all ready to go */
	    *latp = op->s_sublat;
	    *longp = op->s_sublng;
	} else {
	    double gst;
	    double ra, dec;
	    ra = op->s_ra;
	    dec = op->s_dec;
	    if (epoch != EOD)
		precess (epoch, mjd, &ra, &dec);

	    *latp = dec;

	    utc_gst (mjd_day(mjd), mjd_hr(mjd), &gst);
	    *longp = ra - hrrad(gst);	/* remember: we want +E */
	    range (longp, 2*PI);
	    if (*longp > PI)
		*longp -= 2*PI;
	}
}

/* show the stats for the latest object in the trails list.
 * if it's of type EARTHSAT then display its s_ fields;
 * otherwise turn off the display of these items.
 */
static void
e_show_esat_stats ()
{
	ESatStatTable *stp;
	int unitspref;
	Obj *op = &trails[ntrails-1].t_obj;

	if (op->type != EARTHSAT) {
	    XtUnmanageChild (estattable[ES_ELEV].lw);
	    XtUnmanageChild (estattable[ES_ELEV].pbw);
	    XtUnmanageChild (estattable[ES_RANGE].lw);
	    XtUnmanageChild (estattable[ES_RANGE].pbw);
	    XtUnmanageChild (estattable[ES_RANGER].lw);
	    XtUnmanageChild (estattable[ES_RANGER].pbw);
	    XtUnmanageChild (estattable[ES_ECLIPSED].lw);
	    XtUnmanageChild (estattable[ES_ECLIPSED].pbw);
	    return;
	} else {
	    XtManageChild (estattable[ES_ELEV].lw);
	    XtManageChild (estattable[ES_ELEV].pbw);
	    XtManageChild (estattable[ES_RANGE].lw);
	    XtManageChild (estattable[ES_RANGE].pbw);
	    XtManageChild (estattable[ES_RANGER].lw);
	    XtManageChild (estattable[ES_RANGER].pbw);
	    XtManageChild (estattable[ES_ECLIPSED].lw);
	    XtManageChild (estattable[ES_ECLIPSED].pbw);
	}

	unitspref = pref_get (PREF_UNITS);

	stp = &estattable[ES_ELEV];
	if (stp->enumcode != ES_ELEV) {
	    printf ("estattable order is wrong\n");
	    exit(1);
	}
	if (unitspref == PREF_ENGLISH) {
	    f_showit (stp->lw, "Elevation(mi):");
	    f_double (stp->pbw, "%6.0f", op->s_elev*FTPM/5280.0);
	} else {
	    f_showit (stp->lw, "Elevation(km):");
	    f_double (stp->pbw, "%6.0f", op->s_elev/1000.0);
	}

	stp = &estattable[ES_RANGE];
	if (stp->enumcode != ES_RANGE) {
	    printf ("estattable order is wrong\n");
	    exit(1);
	}
	if (unitspref == PREF_ENGLISH) {
	    f_showit (stp->lw, "Range(mi):");
	    f_double (stp->pbw, "%6.0f", op->s_range*FTPM/5280.0);
	} else {
	    f_showit (stp->lw, "Range(km):");
	    f_double (stp->pbw, "%6.0f", op->s_range/1000.0);
	}

	stp = &estattable[ES_RANGER];
	if (stp->enumcode != ES_RANGER) {
	    printf ("estattable order is wrong\n");
	    exit(1);
	}
	if (unitspref == PREF_ENGLISH) {
	    f_showit (stp->lw, "Range Rate(f/s):");
	    f_double (stp->pbw, "%6.0f", op->s_rangev*FTPM);
	} else {
	    f_showit (stp->lw, "Range Rate(m/s):");
	    f_double (stp->pbw, "%6.0f", op->s_rangev);
	}

	stp = &estattable[ES_ECLIPSED];
	if (stp->enumcode != ES_ECLIPSED) {
	    printf ("estattable order is wrong\n");
	    exit(1);
	}
	f_double (stp->pbw, "%.1g", op->s_eclipsed ? 1.0 : 0.0);
}

/* given:
 *   sin and cos of viewpoint latitude, svl, cvl;
 *   longitude of viewpoint, vL;
 *   latitude and longitude of a point p, pl, pL;
 * find:
 *   sin and cos of angle between viewpoint and point p, sRp, cRp;
 *   sin and cos of angle from N pole to point p as seen from viewpoint,
 *     sAp, cAp;
 */   
static void
e_coord (svl, cvl, vL, pl, pL, sRp, cRp, sAp, cAp)
double svl, cvl;	/* sin/cos of viewpoint lat, rads, +N */
double vL;		/* longitude of viewpoint, rads, +E */
double pl, pL;		/* point p lat, rads, +N; long, rads, +E */
double *sRp, *cRp;	/* RETURN sin/cos angle from viewpoint to point p */
double *sAp, *cAp;	/* RETURN sin/cos angle CW from pole to p, rads */
{
	double cosR, A;

	solve_sphere (pL - vL, PI/2 - pl, svl, cvl, &cosR, &A);
	*sRp = sqrt(1.0 - cosR*cosR);
	*cRp = cosR;
	*sAp = sin(A);
	*cAp = cos(A);
}

/* draw all the objects in the trails list onto e_pm relative to elat/elng */
static void
e_drawobjects (r, wb, hb)
unsigned r;		/* Earth circle radius, pixels */
unsigned wb, hb;	/* width and height borders, pixels */
{
	Trail *tp, *ftp, *ltp;	/* working, first and last */

	/* only show the last entry if trails is turned off.
	 * (they are not actually forgotten until the next update)
	 */
	if (wants[TRAILS])
	    ftp = trails;
	else
	    ftp = trails + ntrails - 1;
	ltp = trails + ntrails - 1;

	for (tp = ftp; tp <= ltp; tp++) {
	    double el;
	    el = tp->t_obj.type == EARTHSAT ? tp->t_obj.s_elev : 1e9;
	    e_drawsat (r, wb, hb, tp->t_sublat, tp->t_sublng, el);
	}
}

/* draw circles onto e_pm within circle of radius r and width and height
 * borders wb and hb showing where the satellite is seen as being 0, 30 and 60
 * degrees altitude above horizon as well.
 * also draw a crosshair at the actual location.
 * subobject location.
 */
static void
e_drawsat (r, wb, hb, slat, slng, el)
unsigned r, wb, hb;	/* radius and width/height borders of circle to use */
double slat, slng;	/* satellite's lat and lng */
double el;		/* satellite's elevation above surface, m */
{
	double rad;	/* viewing altitude radius, rads */

	e_viewrad (el, degrad(0.0), &rad);
	e_drawcircle (r, wb, hb, slat, slng, rad);
	e_viewrad (el, degrad(30.0), &rad);
	e_drawcircle (r, wb, hb, slat, slng, rad);
	e_viewrad (el, degrad(60.0), &rad);
	e_drawcircle (r, wb, hb, slat, slng, rad);
	XSetForeground (XtD, e_olgc, ecolors[OBJC].p);
	e_drawcross (r, wb, hb, slat, slng, CROSSH);
}

/* assuming the current vantage point of elat/elng, draw a circle around the
 * given lat/long point of given angular radius.
 * all angles in rads.
 * we do it by sweeping an arc from the given location and collecting the end
 *   points. beware going over the horizon.
 */
static void
e_drawcircle (r, wb, hb, slat, slng, rad)
unsigned r, wb, hb;	/* radius and width/height borders of circle to use */
double slat, slng;	/* lat/long of object */
double rad;		/* angular radius of circle to draw */
{
#define	NVCIRSEGS	75
	XPoint xp[NVCIRSEGS+1];
	double cosc = cos(PI/2 - slat);	/* cos/sin of N-pole-to-slat angle */
	double sinc = sin(PI/2 - slat);
	double b = rad;			/* sat-to-arc angle */
	double A;			/* subobject azimuth */
	double cosa;			/* cos of pole-to-arc angle */
	double B;			/* subobj-to-view angle from pole */
	double sR, cR;			/* view-to-arc angle */
	double sT, cT;			/* north-to-arc angle from view */
	int nxp = 0;
	int vis;
	int i;

	/* use the overlay gc, wide lines, the OBJC color */
	XSetLineAttributes (XtD, e_olgc, WIDE_LW, LINE_ST, CAP_ST, JOIN_ST);
	XSetForeground (XtD, e_olgc, ecolors[OBJC].p);

	for (i = 0; i <= NVCIRSEGS; i++) {
	    A = 2*PI/NVCIRSEGS * i;
	    solve_sphere (A, b, cosc, sinc, &cosa, &B);
	    e_coord (selat, celat, elng, PI/2-acos(cosa), B+slng,
							&sR, &cR, &sT, &cT);
	    vis = cR > 0.0;
	    if (vis) {
		e_project (r, wb, hb, sR, sT, cT, &xp[nxp].x, &xp[nxp].y);
		nxp++;
	    }
	    /* draw the line if it just turned invisible or we are done */
	    if ((!vis || i == NVCIRSEGS) && nxp > 0) {
		XDrawLines (XtD, e_pm, e_olgc, xp, nxp, CoordModeOrigin);
		nxp = 0;
	    }
	}
}

/* draw a little crosshair or plussign at the given location with the e_olgc */
static void
e_drawcross (r, wb, hb, lt, lg, style)
unsigned r, wb, hb;	/* radius and width/height borders of circle to use */
double lt, lg;		/* desired center location */
int style;		/* CROSSH or PLUSS */
{
	double lats[4], lngs[4];	/* lats and longs of endpoints */
	XSegment xs[4];			/* one for each cardinal direction */
	double sR, cR;			/* view-to-point angle */
	double sT, cT;			/* north-to-point angle from view */
	double a, cosa;			/* north-to-cross from view */
	double B;			/* cross-width from north */
	short sx, sy;			/* x and y of the center */
	int linew;
	int nxs;
	int vis;
	int i;

	/* find location of center of cross-hair */
	e_coord (selat, celat, elng, lt, lg, &sR, &cR, &sT, &cT);
	vis = cR > 0.0;
	if (!vis)
	    return;	/* center is not visible so forget the rest */
	e_project (r, wb, hb, sR, sT, cT, &sx, &sy);

	/* find longitude sweep to produce given e/w arc */

	switch (style) {
	case CROSSH:
	    solve_sphere (PI/4, CHLEN, sin(lt), cos(lt), &cosa, &B);
	    a = acos(cosa);
	    lats[0] = PI/2-a;		lngs[0] = lg+B;
	    lats[1] = PI/2-a;		lngs[1] = lg-B;
	    solve_sphere (3*PI/4, CHLEN, sin(lt), cos(lt), &cosa, &B);
	    a = acos(cosa);
	    lats[2] = PI/2-a;		lngs[2] = lg+B;
	    lats[3] = PI/2-a;		lngs[3] = lg-B;
	    linew = WIDE_LW;
	    break;
	case PLUSS:
	    solve_sphere (PI/2, PLLEN, sin(lt), cos(lt), &cosa, &B);
	    a = acos(cosa);
	    lats[0] = lt+PLLEN;		lngs[0] = lg;
	    lats[1] = PI/2-a;		lngs[1] = lg+B;
	    lats[2] = PI/2-a;		lngs[2] = lg-B;
	    lats[3] = lt-PLLEN;		lngs[3] = lg;
	    linew = NARROW_LW;
	    break;
	default:
	    printf ("e_drawcross: bad style: %d\n", style);
	    exit (1);
	}

	nxs = 0;
	for (i = 0; i < 4; i++) {
	    e_coord (selat, celat, elng, lats[i], lngs[i], &sR, &cR, &sT, &cT);
	    vis = cR > 0.0;
	    if (vis) {
		e_project (r, wb, hb, sR, sT, cT, &xs[nxs].x1, &xs[nxs].y1);
		xs[nxs].x2 = sx;
		xs[nxs].y2 = sy;
		nxs++;
	    }
	}

	if (nxs > 0) {
	    XSetLineAttributes (XtD, e_olgc, linew, LINE_ST, CAP_ST, JOIN_ST);
	    XDrawSegments (XtD, e_pm, e_olgc, xs, nxs);
	}
}

/* draw the lat/long grid lines */
static void
e_drawgrid (r, wb, hb)
unsigned r, wb, hb;	/* radius and width/height borders of circle to use */
{
	XPoint xp[NLATLNG+1];
	double sR, cR;			/* view-to-point angle */
	double sT, cT;			/* north-to-point angle from view */
	double lt, lg;
	int i, j;
	int nxp;
	int vis;

	/* use the overlay GC, narrow lines, GRIDC color */
	XSetLineAttributes (XtD, e_olgc, NARROW_LW, LINE_ST, CAP_ST, JOIN_ST);
	XSetForeground (XtD, e_olgc, ecolors[GRIDC].p);

	/* draw each line of longitude */
	for (i = 0; i < 360/LNGSTEP; i++) {
	    lg = i * degrad(LNGSTEP);
	    nxp = 0;
	    for (j = 0; j <= NLATLNG; j++) {
		lt = degrad (90 - j*180.0/NLATLNG);
		e_coord (selat, celat, elng, lt, lg, &sR, &cR, &sT, &cT);
		vis = cR > 0.0;
		if (vis) {
		    e_project (r, wb, hb, sR, sT, cT, &xp[nxp].x, &xp[nxp].y);
		    nxp++;
		}
		if ((!vis || j == NLATLNG) && nxp > 0) {
		    XDrawLines (XtD, e_pm, e_olgc, xp, nxp, CoordModeOrigin);
		    nxp = 0;
		}
	    }
	}

	/* draw each line of latitude */
	for (i = 1; i < 180/LATSTEP; i++) {
	    lt = degrad (90 - i*LATSTEP);
	    nxp = 0;
	    for (j = 0; j <= NLATLNG; j++) {
		lg = j * degrad(360.0/NLATLNG);
		e_coord (selat, celat, elng, lt, lg, &sR, &cR, &sT, &cT);
		vis = cR > 0.0;
		if (vis) {
		    e_project (r, wb, hb, sR, sT, cT, &xp[nxp].x, &xp[nxp].y);
		    nxp++;
		}
		if ((!vis || j == NLATLNG) && nxp > 0) {
		    XDrawLines (XtD, e_pm, e_olgc, xp, nxp, CoordModeOrigin);
		    nxp = 0;
		}
	    }
	}
}

/* project a point onto a flat drawing surface.
 * point is specified in angles with respect to the current view center.
 */
static void
e_project (r, wb, hb, sR, sT, cT, xp, yp)
unsigned r;		/* radius of drawing surface circle */
unsigned wb, hb;	/* width/height borders between circle and edges */
double sR;		/* sin of radius from view center to point */
double sT, cT;		/* sin/cos of azimuth of point wrt view center */
short *xp, *yp;		/* projected location onto drawing surface */
{
	*xp = wb + r + (int)floor(r*sR*sT + 0.5);
	*yp = hb +r - (int)floor(r*sR*cT + 0.5);
}

/* given radius and X-coord x/y, return current Earth lat/long.
 * return 1 if inside the circle, else 0.
 */
static int
e_uncoord (r, x, y, ltp, lgp)
unsigned int r;
int x, y;
double *ltp, *lgp;
{
	double X, Y;	/* coord but signed from center, +x right +y up */
	double A;	/* angle btwn pole to x/y as from elat/elng, rads +cw */
	double b;	/* angle from elat/elng to x/y */
	double R;	/* pixels from center */
	double cosa;	/* cos of latitude */
	double B;	/* angle away from elng */

	X = x - (int)r;
	Y = (int)r - y;
	R = sqrt (X*X + Y*Y);
	if (R >= r)
	    return (0);

	if (fabs(Y) < 1e-5) {
	    if (X < 0.0)
		A = -PI/2;
	    else
		A = PI/2;
	} else
	    A = atan2 (X, Y);
	b = asin(R/r);

	solve_sphere (A, b, selat, celat, &cosa, &B);

	*ltp = asin(cosa);
	*lgp = elng + B;
	range (lgp, 2*PI);
	if (*lgp >= PI)
	    *lgp -= 2*PI;

	return (1);
}

/* draw everything: fields (always) and the picture (if managed) */
static void
e_all (np)
Now *np;
{
	double objlat, objlng;

	watch_cursor(1);

	if (!trails) {
	    printf ("e_all(): no trails\n");
	    exit (1);
	}

	/* put up the current time */
	timestamp (np, e_dt_w);

	/* get the current location of the object */
	objlat = trails[ntrails-1].t_sublat;
	objlng = trails[ntrails-1].t_sublng;

	/* point at it if tracking is on */
	if (wants[TRACK])
	    e_setelatlng (objlat, objlng);

	/* update the scale -- remember we want +W longitude */
	XmScaleSetValue (lat_w, (int)floor(raddeg(elat)+0.5));
	XmScaleSetValue (long_w, (int)floor(raddeg(-elng)+0.5));

	/* display the lat and long of the current object.
	 * N.B. we want to display longitude as +W in range of -PI..+PI
	 */
	f_dms_angle (estattable[ES_SUBLONG].pbw, -objlng);
	f_dms_angle (estattable[ES_SUBLAT].pbw, objlat);

	/* show the other stats too if applicable */
	e_show_esat_stats ();

	/* get the text out while waiting for the map */
	XFlush (XtD);

	/* display the picture if we are up now for sure now.
	 * N.B. don't just use whether eform_w is managed: if we are looping
	 * and get managed drawing occurs before the first expose makes the pm.
	 */
	if (e_pm) {
	    e_map (np);
	    e_copy_pm();
	}

	watch_cursor(0);
}

/* find size and borders of circle for drawing earth */
static void
e_getcircle (wp, hp, rp, xbp, ybp)
unsigned int *wp, *hp;          /* overall width and height */
unsigned int *rp;               /* circle radius */
unsigned int *xbp, *ybp;        /* x and y border */
{
	Display *dsp = XtDisplay(e_da_w);
	Window win = XtWindow(e_da_w);
	Window root;
	int x, y;
	unsigned int w, h;
	unsigned int bw, d;

	XGetGeometry (dsp, win, &root, &x, &y, wp, hp, &bw, &d);

	w = *wp/2;
	h = *hp/2;
	*rp = w > h ? h : w;    /* radius */
	*xbp = w - *rp;         /* x border */
	*ybp = h - *rp;         /* y border */

}

/* draw everything centered at elat/elng onto e_pm.
 */
static void
e_map (np)
Now *np;
{
	Display *dsp = XtDisplay(e_da_w);
	unsigned int w, h, r, wb, hb;

	/* get size of the rendering area */
	e_getcircle (&w, &h, &r, &wb, &hb);

	/* clear the window */
	XSetForeground (dsp, e_gc, e_bg);
	XFillRectangle (dsp, e_pm, e_gc, 0, 0, w, h);

	/* draw sunlit portion of earth.
	 * not drawn with xor so put it first.
	 */
	if (wants[SUNLIGHT])
	    e_sunside (np, r, wb, hb);

	/* draw coord grid */
	if (wants[GRID])
	    e_drawgrid (r, wb, hb);

	/* draw each continent border */
	e_drawcontinents (r, wb, hb);

	/* draw each site */
	if (wants[SITES])
	    e_drawsites (r, wb, hb);

	/* draw each object */
	if (wants[OBJ])
	    e_drawobjects (r, wb, hb);

	/* mark the mainmenu location */
	e_mainmenuloc (np, r, wb, hb);
}

/* draw the solid gibbous or crescent sun-lit portion of the Earth.
 */
static void
e_sunside (np, r, wb, hb)
Now *np;		/* circumstances */
unsigned int r, wb, hb;	/* circle radius, width and height borders in pixmap */
{
#define NSPTS	97	/* number of gibbous/crescent angles.
			 * N.B. be sure loop below never generates 90 or 270
			 */
	Display *dsp = XtDisplay(e_da_w);
	XPoint xp[NSPTS];
	double sslat, sslong;	/* subsolar lat/long, rads, +N +E */
	double ssl, csl;	/* sin/cos of sslat */
	double sR, cR;		/* sin/cos of angle between vp and some pt */
	double A;		/* angle frm pole to sme point as seen from vp*/
	double sA, cA;		/* sin/cos of A */
	int i;

	/* start with the lit semicircle. */
	e_subobject (np, SUN, &sslat, &sslong);
	ssl = sin(sslat);
	csl = cos(sslat);
	e_coord (selat, celat, elng, sslat, sslong, &sR, &cR, &sA, &cA);
	if (fabs(cA) < 1.e-5) {
	    if (sA > 0.0)
		A = PI/2;
	    else
		A = -PI/2;
	} else
	    A = atan2 (sA, cA);
	range (&A, 2*PI);
	XSetForeground (dsp, e_gc, ecolors[SUNC].p);
	XFillArc (dsp, e_pm, e_gc, wb, hb, 2*r, 2*r, (int)raddeg(2*PI-A)*64,
									180*64);

	/* add or subtract from the semicircle to form gibbous or crescent.
	 * do it by finding the circle of points that lie PI/2 from the
	 *   subsolar point and projecting from the viewpoint.
	 * if subsolar point is over the horizon we draw bg and form a crescent;
	 *   else we draw in fg and form a gibbous.
	 */
	XSetForeground (dsp, e_gc, cR < 0.0 ? e_bg : ecolors[SUNC].p);
	for (i = 0; i < NSPTS; i++) {
	    double T = degrad(i*360.0/NSPTS);	/* pole to p as seen frm subso*/
	    double sT = sin(T), cT = cos(T);
	    double plat = asin (csl*cT);	/* latitude of p */
	    double plong = atan2(sT, -ssl*cT) + sslong;	/* long of p */
	    e_coord (selat, celat, elng, plat, plong, &sR, &cR, &sA, &cA);
	    e_project (r, wb, hb, sR, sA, cA, &xp[i].x, &xp[i].y);
	}
	XFillPolygon (dsp, e_pm, e_gc, xp, NSPTS, Convex, CoordModeOrigin);
}

/* draw each continent border */
static void
e_drawcontinents (r, wb, hb)
unsigned r, wb, hb;
{
#define	PTCACHE		512		/* number of XPoints to cache */
	Display *dsp = XtDisplay(e_da_w);
	double sA, cA, sR, cR;
	XPoint xp[PTCACHE];
	MRegion *rp;
	MCoord *cp;
	int nxp;

	/* use the overlay GC, wide lines and the BORDERC color */
	XSetLineAttributes (dsp, e_olgc, WIDE_LW, LINE_ST, CAP_ST, JOIN_ST);
	XSetForeground (dsp, e_olgc, ecolors[BORDERC].p);

	for (rp = ereg; rp < ereg + nereg; rp++) {
	    MCoord *lastcp = rp->mcp + rp->nmcp - 1;
	    nxp = 0;
	    for (cp = rp->mcp; cp <= lastcp; cp++) {
		int vis;
		e_coord (selat, celat, elng, degrad(cp->lt/100.0),
				    degrad(cp->lg)/100.0, &sR, &cR, &sA, &cA);
		vis = cR > 0.0;
		if (vis && nxp < XtNumber(xp)) {
		    e_project (r, wb, hb, sR, sA, cA, &xp[nxp].x, &xp[nxp].y);
		    nxp++;
		}
		if (!vis || cp == lastcp) {
		    if (nxp > 1)
			XDrawLines(dsp, e_pm, e_olgc, xp, nxp, CoordModeOrigin);
		    nxp = 0;
		}
	    }
	}
}

/* draw each site */
static void
e_drawsites (r, wb, hb)
unsigned r, wb, hb;
{
#define	NPCACHE		1024		/* number of XPoints to cache */
	Display *dsp = XtDisplay(e_da_w);
	double sA, cA, sR, cR;
	XPoint xps[NPCACHE];
	Site *sip;
	int nxp;

	/* use the overlay GC and the SITEC color */
	XSetForeground (dsp, e_olgc, ecolors[SITEC].p);

	nxp = 0;
	for (sip = sites; sip; sip = sip->si_nxt) {
	    e_coord (selat, celat, elng, sip->si_lat, sip->si_lng,
							&sR, &cR, &sA, &cA);
	    if (cR > 0.0) {
		/* show each site as a little square */
		short x, y;
		e_project (r, wb, hb, sR, sA, cA, &x, &y);
		xps[nxp].x = x;		xps[nxp].y = y;		nxp++;
		xps[nxp].x = x+1;	xps[nxp].y = y;		nxp++;
		xps[nxp].x = x;		xps[nxp].y = y+1;	nxp++;
		xps[nxp].x = x+1;	xps[nxp].y = y+1;	nxp++;
	    }
	    if (nxp > XtNumber(xps)-4 || sip->si_nxt == NULL) {
		if (nxp > 0)
		    XDrawPoints (dsp, e_pm, e_olgc, xps, nxp, CoordModeOrigin);
		nxp = 0;
	    }
	}
}

/* mark the mainmenu location */
static void
e_mainmenuloc (np, r, wb, hb)
Now *np;
unsigned r, wb, hb;
{
	XSetForeground (XtD, e_olgc, ecolors[HEREC].p);
	e_drawcross (r, wb, hb, lat, lng, PLUSS);
}

/* given a height above the earth, in meters, and an altitude above the
 * horizon, in rads, return the great-circle angular distance from the subpoint
 * to the point at which the given height appears at the given altitude, in
 * rads.
 */
static void
e_viewrad (height, alt, radp)
double height;	/* satellite elevation, m above mean earth */
double alt;	/* viewing altitude, rads above horizon */
double *radp;	/* great-circle distance from subpoint to viewing circle, rads*/
{
	*radp = acos(ERAD/(ERAD+height)*cos(alt)) - alt;
}

/* discard any existing trail history information and add just one */
static void
e_resettrails(np)
Now *np;
{
	if (trails) {
	    XtFree ((char *)trails);
	    trails = 0;
	}
	ntrails = 0;

	e_addtrail (np);
}

/* add an entry to the trails list.
 * avoid dups.
 */
static void
e_addtrail (np)
Now *np;
{
	Trail *tp;
	Obj *op;
	int new;

	op = db_basic (object_dbidx);

	/* prepare for checking dups if there is at least one trail entry.
	 * dups disappear because we mat be doing some drawing with xor.
	 */
	if (trails) {
	    tp = &trails[ntrails-1];
	    new = memcmp (np, &tp->t_now, sizeof(Now)) != 0
				|| memcmp (op, &tp->t_obj, sizeof(ObjES)) != 0;
	}

	/* add a trail entry for the new location if we don't have any now or
	 * the new entry would not be a dup.
	 */
	if (!trails || new) {
	    trails = (Trail *)
			XtRealloc ((char *)trails, sizeof(Trail)*(ntrails+1));
	    tp = &trails[ntrails];
	    tp->t_now = *np;
	    tp->t_obj = *op;
	    e_subobject (np, object_dbidx, &tp->t_sublat, &tp->t_sublng);
	    ntrails++;
	}
}
